Update copyright year
[openssl.git] / config
diff --git a/config b/config
index 1fef03e3910377bccf918b5aeb17adb1a74d62bd..b8adf3499953d4cb3eb6f10f299fb7e2bb0f37d7 100755 (executable)
--- a/config
+++ b/config
@@ -1,5 +1,5 @@
 #!/bin/sh
 #!/bin/sh
-# Copyright 1998-2016 The OpenSSL Project Authors. All Rights Reserved.
+# Copyright 1998-2018 The OpenSSL Project Authors. All Rights Reserved.
 #
 # Licensed under the OpenSSL license (the "License").  You may not use
 # this file except in compliance with the License.  You can obtain a copy
 #
 # Licensed under the OpenSSL license (the "License").  You may not use
 # this file except in compliance with the License.  You can obtain a copy
@@ -11,7 +11,8 @@
 #
 # Do "config -h" for usage information.
 SUFFIX=""
 #
 # Do "config -h" for usage information.
 SUFFIX=""
-TEST="false"
+DRYRUN="false"
+VERBOSE="false"
 EXE=""
 THERE=`dirname $0`
 
 EXE=""
 THERE=`dirname $0`
 
@@ -20,11 +21,13 @@ for i
 do
 case "$i" in 
 -d*) options=$options" --debug";;
 do
 case "$i" in 
 -d*) options=$options" --debug";;
--t*) TEST="true";;
--h*) TEST="true"; cat <<EOF
+-t*) DRYRUN="true" VERBOSE="true";;
+-v*) VERBOSE="true";;
+-h*) DRYRUN="true"; cat <<EOF
 Usage: config [options]
  -d    Build with debugging when possible.
  -t    Test mode, do not run the Configure perl script.
 Usage: config [options]
  -d    Build with debugging when possible.
  -t    Test mode, do not run the Configure perl script.
+ -v    Verbose mode, show the exact Configure call that is being made.
  -h    This help.
 
 Any other text will be passed to the Configure perl script.
  -h    This help.
 
 Any other text will be passed to the Configure perl script.
@@ -32,10 +35,20 @@ See INSTALL for instructions.
 
 EOF
 ;;
 
 EOF
 ;;
-*) options=$options" $i" ;;
+*)  i=`echo "$i" | sed -e "s|'|'\\\\\\''|g"`
+    options="$options '$i'" ;;
 esac
 done
 
 esac
 done
 
+# Environment that's being passed to Configure
+__CNF_CPPDEFINES=
+__CNF_CPPINCLUDES=
+__CNF_CPPFLAGS=
+__CNF_CFLAGS=
+__CNF_CXXFLAGS=
+__CNF_LDFLAGS=
+__CNF_LDLIBS=
+
 # First get uname entries that we use below
 
 [ "$MACHINE" ] || MACHINE=`(uname -m) 2>/dev/null` || MACHINE="unknown"
 # First get uname entries that we use below
 
 [ "$MACHINE" ] || MACHINE=`(uname -m) 2>/dev/null` || MACHINE="unknown"
@@ -184,6 +197,10 @@ case "${SYSTEM}:${RELEASE}:${VERSION}:${MACHINE}" in
         echo "${MACH}-${ARCH}-freebsd${VERS}"; exit 0
         ;;
 
         echo "${MACH}-${ARCH}-freebsd${VERS}"; exit 0
         ;;
 
+    DragonFly:*)
+       echo "${MACHINE}-whatever-dragonfly"; exit 0
+       ;;
+
     FreeBSD:*)
        echo "${MACHINE}-whatever-freebsd"; exit 0
        ;;
     FreeBSD:*)
        echo "${MACHINE}-whatever-freebsd"; exit 0
        ;;
@@ -223,21 +240,6 @@ case "${SYSTEM}:${RELEASE}:${VERSION}:${MACHINE}" in
        esac
        ;;
 
        esac
        ;;
 
-    QNX:*)
-       case "$RELEASE" in
-           4*)
-               echo "${MACHINE}-whatever-qnx4"
-               ;;
-           6*)
-               echo "${MACHINE}-whatever-qnx6"
-               ;;
-           *)
-               echo "${MACHINE}-whatever-qnx"
-               ;;
-       esac
-       exit 0
-       ;;
-
     Paragon*:*:*:*)
        echo "i860-intel-osf1"; exit 0
        ;;
     Paragon*:*:*:*)
        echo "i860-intel-osf1"; exit 0
        ;;
@@ -313,6 +315,15 @@ case "${SYSTEM}:${RELEASE}:${VERSION}:${MACHINE}" in
        echo "${MACHINE}-v11-${SYSTEM}"; exit 0;
        ;;
 
        echo "${MACHINE}-v11-${SYSTEM}"; exit 0;
        ;;
 
+    # The following combinations are supported
+    # MINGW64* on x86_64 => mingw64
+    # MINGW32* on x86_64 => mingw
+    # MINGW32* on i?86 => mingw
+    #
+    # MINGW64* on i?86 isn't expected to work...
+    MINGW64*:*:*:x86_64)
+       echo "${MACHINE}-whatever-mingw64"; exit 0;
+       ;;
     MINGW*)
        echo "${MACHINE}-whatever-mingw"; exit 0;
        ;;
     MINGW*)
        echo "${MACHINE}-whatever-mingw"; exit 0;
        ;;
@@ -416,19 +427,6 @@ if [ "$SYSTEM" = "SunOS" ]; then
   fi
 fi
 
   fi
 fi
 
-if [ "${SYSTEM}-${MACHINE}" = "Linux-alpha" ]; then
-  # check for Compaq C, expected output is "blah-blah C Vx.x"
-  CCCVER=`(ccc -V 2>&1) 2>/dev/null | \
-       egrep -e '.* C V[0-9]\.[0-9]' | \
-       sed 's/.* C V\([0-9]\)\.\([0-9]\).*/\1\2/'`
-  CCCVER=${CCCVER:-0}
-  if [ $CCCVER -gt 60 ]; then
-    CC=ccc     # overrides gcc!!! well, ccc outperforms inoticeably
-               # only on hash routines and des, otherwise gcc (2.95)
-               # keeps along rather tight...
-  fi
-fi
-
 if [ "${SYSTEM}" = "AIX" ]; then       # favor vendor cc over gcc
     (cc) 2>&1 | grep -iv "not found" > /dev/null && CC=cc
 fi
 if [ "${SYSTEM}" = "AIX" ]; then       # favor vendor cc over gcc
     (cc) 2>&1 | grep -iv "not found" > /dev/null && CC=cc
 fi
@@ -451,29 +449,15 @@ case "$GUESSOS" in
     OUT=uClinux-dist
        ;;
   mips3-sgi-irix)
     OUT=uClinux-dist
        ;;
   mips3-sgi-irix)
-       #CPU=`(hinv -t cpu) 2>/dev/null | head -1 | sed 's/^CPU:[^R]*R\([0-9]*\).*/\1/'`
-       #CPU=${CPU:-0}
-       #if [ $CPU -ge 5000 ]; then
-       #       options="$options -mips4"
-       #else
-       #       options="$options -mips3"
-       #fi
        OUT="irix-mips3-$CC"
        ;;
   mips4-sgi-irix64)
        echo "WARNING! If you wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure irix64-mips4-$CC' *manually*."
        OUT="irix-mips3-$CC"
        ;;
   mips4-sgi-irix64)
        echo "WARNING! If you wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure irix64-mips4-$CC' *manually*."
-       if [ "$TEST" = "false" -a -t 1 ]; then
+       if [ "$DRYRUN" = "false" -a -t 1 ]; then
          echo "         You have about 5 seconds to press Ctrl-C to abort."
          (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
          echo "         You have about 5 seconds to press Ctrl-C to abort."
          (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
-        #CPU=`(hinv -t cpu) 2>/dev/null | head -1 | sed 's/^CPU:[^R]*R\([0-9]*\).*/\1/'`
-        #CPU=${CPU:-0}
-        #if [ $CPU -ge 5000 ]; then
-        #        options="$options -mips4"
-        #else
-        #        options="$options -mips3"
-        #fi
        OUT="irix-mips3-$CC"
        ;;
   ppc-apple-rhapsody) OUT="rhapsody-ppc-cc" ;;
        OUT="irix-mips3-$CC"
        ;;
   ppc-apple-rhapsody) OUT="rhapsody-ppc-cc" ;;
@@ -482,7 +466,7 @@ case "$GUESSOS" in
        if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke '$THERE/Configure darwin64-ppc-cc' *manually*."
        if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke '$THERE/Configure darwin64-ppc-cc' *manually*."
-           if [ "$TEST" = "false" -a -t 1 ]; then
+           if [ "$DRYRUN" = "false" -a -t 1 ]; then
              echo "         You have about 5 seconds to press Ctrl-C to abort."
              (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
            fi
              echo "         You have about 5 seconds to press Ctrl-C to abort."
              (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
            fi
@@ -497,11 +481,9 @@ case "$GUESSOS" in
        if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke 'KERNEL_BITS=64 $THERE/config $options'."
        if [ "$ISA64" = "1" -a -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke 'KERNEL_BITS=64 $THERE/config $options'."
-           if [ "$TEST" = "false" -a -t 1 ]; then
+           if [ "$DRYRUN" = "false" -a -t 1 ]; then
              echo "         You have about 5 seconds to press Ctrl-C to abort."
              echo "         You have about 5 seconds to press Ctrl-C to abort."
-             # The stty technique used elsewhere doesn't work on
-             # MacOS. At least, right now on this Mac.
-             sleep 5
+             (trap "stty `stty -g`; exit 1" 2; stty -icanon min 0 time 50; read waste; exit 0) <&1 || exit
            fi
        fi
        if [ "$ISA64" = "1" -a "$KERNEL_BITS" = "64" ]; then
            fi
        fi
        if [ "$ISA64" = "1" -a "$KERNEL_BITS" = "64" ]; then
@@ -510,26 +492,18 @@ case "$GUESSOS" in
            OUT="darwin-i386-cc"
        fi ;;
   x86_64-apple-darwin*)
            OUT="darwin-i386-cc"
        fi ;;
   x86_64-apple-darwin*)
-       if [ -z "$KERNEL_BITS" ]; then
-           echo "WARNING! If you wish to build 32-bit library, then you have to"
-           echo "         invoke 'KERNEL_BITS=32 $THERE/config $options'."
-           if [ "$TEST" = "false" -a -t 1 ]; then
-             echo "         You have about 5 seconds to press Ctrl-C to abort."
-             # The stty technique used elsewhere doesn't work on
-             # MacOS. At least, right now on this Mac.
-             sleep 5
-           fi
-       fi
        if [ "$KERNEL_BITS" = "32" ]; then
            OUT="darwin-i386-cc"
        else
            OUT="darwin64-x86_64-cc"
        fi ;;
   armv6+7-*-iphoneos)
        if [ "$KERNEL_BITS" = "32" ]; then
            OUT="darwin-i386-cc"
        else
            OUT="darwin64-x86_64-cc"
        fi ;;
   armv6+7-*-iphoneos)
-       options="$options -arch%20armv6 -arch%20armv7"
+       __CNF_CFLAGS="$__CNF_CFLAGS -arch%20armv6 -arch%20armv7"
+       __CNF_CXXFLAGS="$__CNF_CXXFLAGS -arch%20armv6 -arch%20armv7"
        OUT="iphoneos-cross" ;;
   *-*-iphoneos)
        OUT="iphoneos-cross" ;;
   *-*-iphoneos)
-       options="$options -arch%20${MACHINE}"
+       __CNF_CFLAGS="$__CNF_CFLAGS -arch%20${MACHINE}"
+       __CNF_CXXFLAGS="$__CNF_CXXFLAGS -arch%20${MACHINE}"
        OUT="iphoneos-cross" ;;
   arm64-*-iphoneos|*-*-ios64)
        OUT="ios64-cross" ;;
        OUT="iphoneos-cross" ;;
   arm64-*-iphoneos|*-*-ios64)
        OUT="ios64-cross" ;;
@@ -541,9 +515,12 @@ case "$GUESSOS" in
        esac
        if [ "$CC" = "gcc" ]; then
            case ${ISA:-generic} in
        esac
        if [ "$CC" = "gcc" ]; then
            case ${ISA:-generic} in
-           EV5|EV45)           options="$options -mcpu=ev5";;
-           EV56|PCA56)         options="$options -mcpu=ev56";;
-           *)                  options="$options -mcpu=ev6";;
+           EV5|EV45)           __CNF_CFLAGS="$__CNF_CFLAGS -mcpu=ev5"
+                               __CNF_CXXFLAGS="$__CNF_CFLAGS -mcpu=ev5";;
+           EV56|PCA56)         __CNF_CFLAGS="$__CNF_CFLAGS -mcpu=ev56"
+                               __CNF_CXXFLAGS="$__CNF_CXXFLAGS -mcpu=ev56";;
+           *)                  __CNF_CFLAGS="$__CNF_CFLAGS -mcpu=ev6"
+                               __CNF_CXXFLAGS="$__CNF_CXXFLAGS -mcpu=ev6";;
            esac
        fi
        ;;
            esac
        fi
        ;;
@@ -551,7 +528,7 @@ case "$GUESSOS" in
        if [ -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke '$THERE/Configure linux-ppc64' *manually*."
        if [ -z "$KERNEL_BITS" ]; then
            echo "WARNING! If you wish to build 64-bit library, then you have to"
            echo "         invoke '$THERE/Configure linux-ppc64' *manually*."
-           if [ "$TEST" = "false" -a -t 1 ]; then
+           if [ "$DRYRUN" = "false" -a -t 1 ]; then
                echo "         You have about 5 seconds to press Ctrl-C to abort."
                (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
            fi
                echo "         You have about 5 seconds to press Ctrl-C to abort."
                (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
            fi
@@ -560,7 +537,12 @@ case "$GUESSOS" in
            OUT="linux-ppc64"
        else
            OUT="linux-ppc"
            OUT="linux-ppc64"
        else
            OUT="linux-ppc"
-           (echo "__LP64__" | gcc -E -x c - 2>/dev/null | grep "^__LP64__" 2>&1 > /dev/null) || options="$options -m32"
+           if (echo "__LP64__" | gcc -E -x c - 2>/dev/null | grep "^__LP64__" 2>&1 > /dev/null); then
+               :;
+           else
+               __CNF_CFLAGS="$__CNF_CFLAGS -m32"
+               __CNF_CXXFLAGS="$__CNF_CXXFLAGS -m32"
+           fi
        fi
        ;;
   ppc64le-*-linux2) OUT="linux-ppc64le" ;;
        fi
        ;;
   ppc64le-*-linux2) OUT="linux-ppc64le" ;;
@@ -568,7 +550,7 @@ case "$GUESSOS" in
   mips64*-*-linux2)
        echo "WARNING! If you wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure linux64-mips64' *manually*."
   mips64*-*-linux2)
        echo "WARNING! If you wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure linux64-mips64' *manually*."
-       if [ "$TEST" = "false" -a -t 1 ]; then
+       if [ "$DRYRUN" = "false" -a -t 1 ]; then
            echo "         You have about 5 seconds to press Ctrl-C to abort."
            (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
            echo "         You have about 5 seconds to press Ctrl-C to abort."
            (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
@@ -585,7 +567,7 @@ case "$GUESSOS" in
        echo "WARNING! If you *know* that your GNU C supports 64-bit/V9 ABI"
        echo "         and wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure linux64-sparcv9' *manually*."
        echo "WARNING! If you *know* that your GNU C supports 64-bit/V9 ABI"
        echo "         and wish to build 64-bit library, then you have to"
        echo "         invoke '$THERE/Configure linux64-sparcv9' *manually*."
-       if [ "$TEST" = "false" -a -t 1 ]; then
+       if [ "$DRYRUN" = "false" -a -t 1 ]; then
          echo "          You have about 5 seconds to press Ctrl-C to abort."
          (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
          echo "          You have about 5 seconds to press Ctrl-C to abort."
          (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        fi
@@ -596,7 +578,8 @@ case "$GUESSOS" in
        sun4u*) OUT="linux-sparcv9" ;;
        sun4m)  OUT="linux-sparcv8" ;;
        sun4d)  OUT="linux-sparcv8" ;;
        sun4u*) OUT="linux-sparcv9" ;;
        sun4m)  OUT="linux-sparcv8" ;;
        sun4d)  OUT="linux-sparcv8" ;;
-       *)      OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
+       *)      OUT="linux-generic32";
+               __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
        esac ;;
   parisc*-*-linux2)
        # 64-bit builds under parisc64 linux are not supported and
        esac ;;
   parisc*-*-linux2)
        # 64-bit builds under parisc64 linux are not supported and
@@ -618,22 +601,31 @@ case "$GUESSOS" in
        CPUSCHEDULE=`echo $CPUSCHEDULE|sed -e 's/7300LC/7100LC/' -e 's/8.00/8000/'`
        # Finish Model transformations
 
        CPUSCHEDULE=`echo $CPUSCHEDULE|sed -e 's/7300LC/7100LC/' -e 's/8.00/8000/'`
        # Finish Model transformations
 
-       options="$options -DB_ENDIAN -mschedule=$CPUSCHEDULE -march=$CPUARCH"
+       __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN"
+       __CNF_CFLAGS="$__CNF_CFLAGS -mschedule=$CPUSCHEDULE -march=$CPUARCH"
+       __CNF_CXXFLAGS="$__CNF_CXXFLAGS -mschedule=$CPUSCHEDULE -march=$CPUARCH"
        OUT="linux-generic32" ;;
   armv[1-3]*-*-linux2) OUT="linux-generic32" ;;
        OUT="linux-generic32" ;;
   armv[1-3]*-*-linux2) OUT="linux-generic32" ;;
-  armv[7-9]*-*-linux2) OUT="linux-armv4"; options="$options -march=armv7-a" ;;
+  armv[7-9]*-*-linux2) OUT="linux-armv4"
+                      __CNF_CFLAGS="$__CNF_CFLAGS -march=armv7-a"
+                      __CNF_CXXFLAGS="$__CNF_CXXFLAGS -march=armv7-a"
+                      ;;
   arm*-*-linux2) OUT="linux-armv4" ;;
   aarch64-*-linux2) OUT="linux-aarch64" ;;
   arm*-*-linux2) OUT="linux-armv4" ;;
   aarch64-*-linux2) OUT="linux-aarch64" ;;
-  sh*b-*-linux2) OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
-  sh*-*-linux2)  OUT="linux-generic32"; options="$options -DL_ENDIAN" ;;
-  m68k*-*-linux2) OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
-  s390-*-linux2) OUT="linux-generic32"; options="$options -DB_ENDIAN" ;;
+  sh*b-*-linux2) OUT="linux-generic32";
+                __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
+  sh*-*-linux2)         OUT="linux-generic32";
+                __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DL_ENDIAN" ;;
+  m68k*-*-linux2) OUT="linux-generic32";
+                 __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
+  s390-*-linux2) OUT="linux-generic32";
+                __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
   s390x-*-linux2)
        # To be uncommented when glibc bug is fixed, see Configure...
        #if egrep -e '^features.* highgprs' /proc/cpuinfo >/dev/null ; then
        #  echo "WARNING! If you wish to build \"highgprs\" 32-bit library, then you"
        #  echo "         have to invoke './Configure linux32-s390x' *manually*."
   s390x-*-linux2)
        # To be uncommented when glibc bug is fixed, see Configure...
        #if egrep -e '^features.* highgprs' /proc/cpuinfo >/dev/null ; then
        #  echo "WARNING! If you wish to build \"highgprs\" 32-bit library, then you"
        #  echo "         have to invoke './Configure linux32-s390x' *manually*."
-       #  if [ "$TEST" = "false" -a -t -1 ]; then
+       #  if [ "$DRYRUN" = "false" -a -t -1 ]; then
        #    echo "         You have about 5 seconds to press Ctrl-C to abort."
        #    (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        #  fi
        #    echo "         You have about 5 seconds to press Ctrl-C to abort."
        #    (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
        #  fi
@@ -646,20 +638,16 @@ case "$GUESSOS" in
        else
            OUT="linux-x86_64"
        fi ;;
        else
            OUT="linux-x86_64"
        fi ;;
-  *86-*-linux2) OUT="linux-elf"
-       if [ "$GCCVER" -gt 28 ]; then
-          if grep '^model.*Pentium' /proc/cpuinfo >/dev/null ; then
-           options="$options -march=pentium"
-          fi
-          if grep '^model.*Pentium Pro' /proc/cpuinfo >/dev/null ; then
-           options="$options -march=pentiumpro"
-          fi
-          if grep '^model.*K6' /proc/cpuinfo >/dev/null ; then
-           options="$options -march=k6"
-          fi
+  *86-*-linux2)
+        # On machines where the compiler understands -m32, prefer a
+        # config target that uses it
+        if $CC -m32 -E -x c /dev/null > /dev/null 2>&1; then
+            OUT="linux-x86"
+        else
+            OUT="linux-elf"
         fi ;;
         fi ;;
-  *-*-linux1) OUT="linux-aout" ;;
-  *-*-linux2) OUT="linux-generic32" ;;
+  *86-*-linux1) OUT="linux-aout" ;;
+  *-*-linux?) OUT="linux-generic32" ;;
   sun4[uv]*-*-solaris2)
        OUT="solaris-sparcv9-$CC"
        ISA64=`(isainfo) 2>/dev/null | grep sparcv9`
   sun4[uv]*-*-solaris2)
        OUT="solaris-sparcv9-$CC"
        ISA64=`(isainfo) 2>/dev/null | grep sparcv9`
@@ -667,7 +655,7 @@ case "$GUESSOS" in
            if [ "$CC" = "cc" -a $CCVER -ge 50 ]; then
                echo "WARNING! If you wish to build 64-bit library, then you have to"
                echo "         invoke '$THERE/Configure solaris64-sparcv9-cc' *manually*."
            if [ "$CC" = "cc" -a $CCVER -ge 50 ]; then
                echo "WARNING! If you wish to build 64-bit library, then you have to"
                echo "         invoke '$THERE/Configure solaris64-sparcv9-cc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -679,7 +667,7 @@ case "$GUESSOS" in
                OUT="solaris64-sparcv9-gcc"
                echo "WARNING! If you wish to build 32-bit library, then you have to"
                echo "         invoke '$THERE/Configure solaris-sparcv9-gcc' *manually*."
                OUT="solaris64-sparcv9-gcc"
                echo "WARNING! If you wish to build 32-bit library, then you have to"
                echo "         invoke '$THERE/Configure solaris-sparcv9-gcc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -687,7 +675,7 @@ case "$GUESSOS" in
                echo "NOTICE! If you *know* that your GNU C supports 64-bit/V9 ABI"
                echo "        and wish to build 64-bit library, then you have to"
                echo "        invoke '$THERE/Configure solaris64-sparcv9-gcc' *manually*."
                echo "NOTICE! If you *know* that your GNU C supports 64-bit/V9 ABI"
                echo "        and wish to build 64-bit library, then you have to"
                echo "        invoke '$THERE/Configure solaris64-sparcv9-gcc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -713,11 +701,15 @@ case "$GUESSOS" in
        ;;
   *-*-sunos4)          OUT="sunos-$CC" ;;
 
        ;;
   *-*-sunos4)          OUT="sunos-$CC" ;;
 
-  *86*-*-bsdi4)                OUT="BSD-x86-elf"; options="$options no-sse2 -ldl" ;;
-  alpha*-*-*bsd*)      OUT="BSD-generic64"; options="$options -DL_ENDIAN" ;;
-  powerpc64-*-*bsd*)   OUT="BSD-generic64"; options="$options -DB_ENDIAN" ;;
+  *86*-*-bsdi4)                OUT="BSD-x86-elf"; options="$options no-sse2";
+                       __CNF_LDFLAGS="$__CNF_LDFLAGS -ldl" ;;
+  alpha*-*-*bsd*)      OUT="BSD-generic64";
+                       __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DL_ENDIAN" ;;
+  powerpc64-*-*bsd*)   OUT="BSD-generic64";
+                       __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DB_ENDIAN" ;;
   sparc64-*-*bsd*)     OUT="BSD-sparc64" ;;
   ia64-*-*bsd*)                OUT="BSD-ia64" ;;
   sparc64-*-*bsd*)     OUT="BSD-sparc64" ;;
   ia64-*-*bsd*)                OUT="BSD-ia64" ;;
+  x86_64-*-dragonfly*)  OUT="BSD-x86_64" ;;
   amd64-*-*bsd*)       OUT="BSD-x86_64" ;;
   *86*-*-*bsd*)                # mimic ld behaviour when it's looking for libc...
                        if [ -L /usr/lib/libc.so ]; then        # [Free|Net]BSD
   amd64-*-*bsd*)       OUT="BSD-x86_64" ;;
   *86*-*-*bsd*)                # mimic ld behaviour when it's looking for libc...
                        if [ -L /usr/lib/libc.so ]; then        # [Free|Net]BSD
@@ -730,9 +722,10 @@ case "$GUESSOS" in
                        *ELF*)  OUT="BSD-x86-elf" ;;
                        *)      OUT="BSD-x86"; options="$options no-sse2" ;;
                        esac ;;
                        *ELF*)  OUT="BSD-x86-elf" ;;
                        *)      OUT="BSD-x86"; options="$options no-sse2" ;;
                        esac ;;
+  *-*-*bsd*)           OUT="BSD-generic32" ;;
+
   x86_64-*-haiku)      OUT="haiku-x86_64" ;;
   *-*-haiku)           OUT="haiku-x86" ;;
   x86_64-*-haiku)      OUT="haiku-x86_64" ;;
   *-*-haiku)           OUT="haiku-x86" ;;
-  *-*-*bsd*)           OUT="BSD-generic32" ;;
 
   *-*-osf)             OUT="osf1-alpha-cc" ;;
   *-*-tru64)           OUT="tru64-alpha-cc" ;;
 
   *-*-osf)             OUT="osf1-alpha-cc" ;;
   *-*-tru64)           OUT="tru64-alpha-cc" ;;
@@ -740,7 +733,8 @@ case "$GUESSOS" in
        if [ "$CC" = "gcc" ]; then
          OUT="unixware-7-gcc" ; options="$options no-sse2"
        else    
        if [ "$CC" = "gcc" ]; then
          OUT="unixware-7-gcc" ; options="$options no-sse2"
        else    
-         OUT="unixware-7" ; options="$options no-sse2 -D__i386__"
+         OUT="unixware-7" ; options="$options no-sse2"
+         __CNF_CPPFLAGS="$__CNF_CPPFLAGS -D__i386__"
        fi
        ;;
   *-*-[Uu]nix[Ww]are20*) OUT="unixware-2.0"; options="$options no-sse2 no-sha512" ;;
        fi
        ;;
   *-*-[Uu]nix[Ww]are20*) OUT="unixware-2.0"; options="$options no-sse2 no-sha512" ;;
@@ -766,20 +760,19 @@ case "$GUESSOS" in
                OUT="hpux-ia64-cc"
              fi
        elif [ $CPU_VERSION -ge 532 ]; then     # PA-RISC 2.x CPU
                OUT="hpux-ia64-cc"
              fi
        elif [ $CPU_VERSION -ge 532 ]; then     # PA-RISC 2.x CPU
-            OUT=${OUT:-"hpux-parisc2-${CC}"}
+            # PA-RISC 2.0 is no longer supported as separate 32-bit
+            # target. This is compensated for by run-time detection
+            # in most critical assembly modules and taking advantage
+            # of 2.0 architecture in PA-RISC 1.1 build.
+            OUT=${OUT:-"hpux-parisc1_1-${CC}"}
             if [ $KERNEL_BITS -eq 64 -a "$CC" = "cc" ]; then
                echo "WARNING! If you wish to build 64-bit library then you have to"
                echo "         invoke '$THERE/Configure hpux64-parisc2-cc' *manually*."
             if [ $KERNEL_BITS -eq 64 -a "$CC" = "cc" ]; then
                echo "WARNING! If you wish to build 64-bit library then you have to"
                echo "         invoke '$THERE/Configure hpux64-parisc2-cc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
             fi
                  echo "         You have about 5 seconds to press Ctrl-C to abort."
                  (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
             fi
-            # PA-RISC 2.0 is no longer supported as separate 32-bit
-            # target. This is compensated for by run-time detection
-            # in most critical assembly modules and taking advantage
-            # of 2.0 architecture in PA-RISC 1.1 build.
-            OUT="hpux-parisc1_1-${CC}"
        elif [ $CPU_VERSION -ge 528 ]; then     # PA-RISC 1.1+ CPU
             OUT="hpux-parisc1_1-${CC}"
        elif [ $CPU_VERSION -ge 523 ]; then     # PA-RISC 1.0 CPU
        elif [ $CPU_VERSION -ge 528 ]; then     # PA-RISC 1.1+ CPU
             OUT="hpux-parisc1_1-${CC}"
        elif [ $CPU_VERSION -ge 523 ]; then     # PA-RISC 1.0 CPU
@@ -787,7 +780,7 @@ case "$GUESSOS" in
        else                                    # Motorola(?) CPU
             OUT="hpux-$CC"
        fi
        else                                    # Motorola(?) CPU
             OUT="hpux-$CC"
        fi
-       options="$options -D_REENTRANT" ;;
+       __CNF_CPPFLAGS="$__CNF_CPPFLAGS -D_REENTRANT" ;;
   *-hpux)      OUT="hpux-parisc-$CC" ;;
   *-aix)
        [ "$KERNEL_BITS" ] || KERNEL_BITS=`(getconf KERNEL_BITMODE) 2>/dev/null`
   *-hpux)      OUT="hpux-parisc-$CC" ;;
   *-aix)
        [ "$KERNEL_BITS" ] || KERNEL_BITS=`(getconf KERNEL_BITMODE) 2>/dev/null`
@@ -807,7 +800,7 @@ case "$GUESSOS" in
            if [ $KERNEL_BITS -eq 64 ]; then
                echo "WARNING! If you wish to build 64-bit kit, then you have to"
                echo "         invoke '$THERE/Configure aix64-cc' *manually*."
            if [ $KERNEL_BITS -eq 64 ]; then
                echo "WARNING! If you wish to build 64-bit kit, then you have to"
                echo "         invoke '$THERE/Configure aix64-cc' *manually*."
-               if [ "$TEST" = "false" -a -t 1 ]; then
+               if [ "$DRYRUN" = "false" -a -t 1 ]; then
                    echo "         You have ~5 seconds to press Ctrl-C to abort."
                    (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
                    echo "         You have ~5 seconds to press Ctrl-C to abort."
                    (trap "stty `stty -g`; exit 0" 2 0; stty -icanon min 0 time 50; read waste) <&1
                fi
@@ -822,11 +815,11 @@ case "$GUESSOS" in
   # these are all covered by the catchall below
   i[3456]86-*-cygwin) OUT="Cygwin-x86" ;;
   *-*-cygwin) OUT="Cygwin-${MACHINE}" ;;
   # these are all covered by the catchall below
   i[3456]86-*-cygwin) OUT="Cygwin-x86" ;;
   *-*-cygwin) OUT="Cygwin-${MACHINE}" ;;
-  x86pc-*-qnx6) OUT="QNX6-i386" ;;
-  *-*-qnx6) OUT="QNX6" ;;
   x86-*-android|i?86-*-android) OUT="android-x86" ;;
   armv[7-9]*-*-android)
   x86-*-android|i?86-*-android) OUT="android-x86" ;;
   armv[7-9]*-*-android)
-      OUT="android-armeabi"; options="$options -march=armv7-a" ;;
+      OUT="android-armeabi"
+      __CNF_CFLAGS="$__CNF_CFLAGS -march=armv7-a"
+      __CNF_CXXFLAGS="$__CNF_CXXFLAGS -march=armv7-a";;
   arm*-*-android) OUT="android-armeabi" ;;
   *) OUT=`echo $GUESSOS | awk -F- '{print $3}'`;;
 esac
   arm*-*-android) OUT="android-armeabi" ;;
   *) OUT=`echo $GUESSOS | awk -F- '{print $3}'`;;
 esac
@@ -840,19 +833,13 @@ esac
 # See whether we can compile Atalla support
 #if [ -f /usr/include/atasi.h ]
 #then
 # See whether we can compile Atalla support
 #if [ -f /usr/include/atasi.h ]
 #then
-#  options="$options -DATALLA"
+#  __CNF_CPPFLAGS="$__CNF_CPPFLAGS -DATALLA"
 #fi
 
 if [ -n "$CONFIG_OPTIONS" ]; then
   options="$options $CONFIG_OPTIONS"
 fi
 
 #fi
 
 if [ -n "$CONFIG_OPTIONS" ]; then
   options="$options $CONFIG_OPTIONS"
 fi
 
-if expr "$options" : '.*no\-asm' > /dev/null; then :; else
-  sh -c "$CROSS_COMPILE${CC:-gcc} -Wa,--help -c -o /tmp/null.$$.o -x assembler /dev/null && rm /tmp/null.$$.o" 2>&1 | \
-  grep \\--noexecstack >/dev/null && \
-  options="$options -Wa,--noexecstack"
-fi
-
 # gcc < 2.8 does not support -march=ultrasparc
 if [ "$OUT" = solaris-sparcv9-gcc -a $GCCVER -lt 28 ]
 then
 # gcc < 2.8 does not support -march=ultrasparc
 if [ "$OUT" = solaris-sparcv9-gcc -a $GCCVER -lt 28 ]
 then
@@ -873,7 +860,7 @@ case "$GUESSOS" in
   i386-*) options="$options 386" ;;
 esac
 
   i386-*) options="$options 386" ;;
 esac
 
-for i in aes bf camellia cast des dh dsa ec hmac idea md2 md5 mdc2 rc2 rc4 rc5 ripemd rsa seed sha
+for i in aes aria bf camellia cast des dh dsa ec hmac idea md2 md5 mdc2 rc2 rc4 rc5 ripemd rsa seed sha sm2 sm3 sm4
 do
   if [ ! -d $THERE/crypto/$i ]
   then
 do
   if [ ! -d $THERE/crypto/$i ]
   then
@@ -923,14 +910,37 @@ OUT="$OUT"
 
 $PERL $THERE/Configure LIST | grep "$OUT" > /dev/null
 if [ $? = "0" ]; then
 
 $PERL $THERE/Configure LIST | grep "$OUT" > /dev/null
 if [ $? = "0" ]; then
-  echo Configuring for $OUT
-
-  if [ "$TEST" = "true" ]; then
-    echo $PERL $THERE/Configure $OUT $options
-  else
-    $PERL $THERE/Configure $OUT $options
+  if [ "$VERBOSE" = "true" ]; then
+    echo /usr/bin/env \
+        __CNF_CPPDEFINES="'$__CNF_CPPDEFINES'" \
+        __CNF_CPPINCLUDES="'$__CNF_CPPINCLUDES'" \
+        __CNF_CPPFLAGS="'$__CNF_CPPFLAGS'" \
+        __CNF_CFLAGS="'$__CNF_CFLAGS'" \
+        __CNF_CXXFLAGS="'$__CNF_CXXFLAGS'" \
+        __CNF_LDFLAGS="'$__CNF_LDFLAGS'" \
+        __CNF_LDLIBS="'$__CNF_LDLIBS'" \
+        $PERL $THERE/Configure $OUT $options
+  fi  
+  if [ "$DRYRUN" = "false" ]; then
+    # eval to make sure quoted options, possibly with spaces inside,
+    # are treated right
+    eval /usr/bin/env \
+        __CNF_CPPDEFINES="'$__CNF_CPPDEFINES'" \
+        __CNF_CPPINCLUDES="'$__CNF_CPPINCLUDES'" \
+        __CNF_CPPFLAGS="'$__CNF_CPPFLAGS'" \
+        __CNF_CFLAGS="'$__CNF_CFLAGS'" \
+        __CNF_CXXFLAGS="'$__CNF_CXXFLAGS'" \
+        __CNF_LDFLAGS="'$__CNF_LDFLAGS'" \
+        __CNF_LDLIBS="'$__CNF_LDLIBS'" \
+        $PERL $THERE/Configure $OUT $options
   fi
 else
   echo "This system ($OUT) is not supported. See file INSTALL for details."
   fi
 else
   echo "This system ($OUT) is not supported. See file INSTALL for details."
+  exit 1
+fi
+
+if [ "$OUT" = "darwin64-x86_64-cc" ]; then
+    echo "WARNING! If you wish to build 32-bit libraries, then you have to"
+    echo "         invoke 'KERNEL_BITS=32 $THERE/config $options'."
 fi
 )
 fi
 )